'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var _redux = require('redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BsAlert = function (_React$Component) {
    _inherits(BsAlert, _React$Component);

    function BsAlert() {
        _classCallCheck(this, BsAlert);

        var _this = _possibleConstructorReturn(this, (BsAlert.__proto__ || Object.getPrototypeOf(BsAlert)).call(this));

        _this.handleAlertDismiss = function () {
            _this.props.deleteFlashMessage();
        };

        _this.state = {
            open: false
        };
        return _this;
    }

    _createClass(BsAlert, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.setState({
                open: nextProps.currentAlert ? true : false,
                type: nextProps.currentAlert ? nextProps.currentAlert.type : this.state.type ? this.state.type : 'success',
                title: nextProps.currentAlert ? nextProps.currentAlert.title : this.state.title,
                text: nextProps.currentAlert ? nextProps.currentAlert.text : this.state.text
            });
        }
    }, {
        key: 'renderFlash',
        value: function renderFlash() {
            if (this.props.flashMessage) {
                return _react2['default'].createElement(
                    _reactBootstrap.Alert,
                    {
                        bsStyle: this.props.flashMessage.style,
                        onDismiss: this.handleAlertDismiss,
                        className: this.props.opts.className,
                        style: this.props.opts.style },
                    _react2['default'].createElement(
                        'strong',
                        null,
                        this.props.flashMessage.title
                    ),
                    ' ',
                    this.props.flashMessage.text
                );
            }
            return _react2['default'].createElement(
                _reactBootstrap.Alert,
                { bsStyle: this.state.style,
                    onDismiss: this.handleAlertDismiss,
                    className: this.props.opts.className,
                    style: this.props.opts.style },
                _react2['default'].createElement(
                    'strong',
                    null,
                    this.state.title
                ),
                ' ',
                this.state.text
            );
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                _reactBootstrap.Collapse,
                { 'in': this.state.open },
                _react2['default'].createElement(
                    'div',
                    { style: this.props.opts.location ? this.props.opts.location : location },
                    this.renderFlash()
                )
            );
        }
    }]);

    return BsAlert;
}(_react2['default'].Component);

function mapStateToProps(state, ownProps) {
    return {
        currentAlert: state.currentAlert
    };
}
function mapDispatchToProps(dispatch) {
    return (0, _redux.bindActionCreators)({ deleteAlert: _actions.deleteAlert }, dispatch);
}

var location = {
    position: 'absolute',
    left: 0,
    right: 0
};

exports['default'] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(BsAlert);